open Arg
open Printf
(** BEGIN ARGV PARSING *)
let port = ref 1234 
let printRead = ref false
let verbose = ref 0
let source = ref ""
let keyspecdoclist =
  [
    "-port",Set_int port,"port  Specifies the port (port) of the server";
    "-crash",Unit(fun () -> prerr_endline "Are you okay??";exit 2),"Crash the pro
gram";
    "-printRead",Unit(fun ()-> printRead:=true), "prints what is read" ;
    "-source",Set_string source, "file: set source file to file";
    "-v",Set_int verbose, "i: set verbose level to i" ;
  ] 
let () = parse keyspecdoclist (fun _ -> failwith "Don't know what to do with anon
ymous argument") "Wrong Argument given!"
    (** END ARGV PARSING *)
let port = !port 
let verbose = !verbose
let source = !source
let v1,v2,v3,v4,v5 = 
  (verbose > 0),
  (verbose > 1),
  (verbose > 2),
  (verbose > 3),
  (verbose > 4)
let () = if v1 then
  (fprintf stderr "\t##Verbose mode set to %d##\n" verbose ; flush stderr);;

let printRead = !printRead
let server ic oc = 
  let file = open_in source in
  let t1 = (Thread.create (fun()->
			     while true do
			       try print_char (input_char ic) ; flush stdout;
			       with End_of_file -> ()
			     done) ())
  and t2 = (Thread.create (fun()->
			     while true do
			       try output_char oc (input_char file); flush oc
			       with End_of_file -> ()
			     done) ())	       
  in Thread.join t1 ; Thread.join t2

;;
let () = 
  let inetAddr =
    Unix.inet_addr_of_string "127.0.0.1" in
  let sockAddr = Unix.ADDR_INET (inetAddr, port) in
    Unix.establish_server (server) sockAddr 
      
